﻿using System;
using System.Windows.Forms;
using CefSharp;
using CefSharp.WinForms;

namespace popup_cefsharp
{
    public partial class frm_main : Form
    {
        public frm_main()
        {
            InitializeComponent();
        }

        //variable browser
        ChromiumWebBrowser chrome, chrome_popup;

        private void initialize_browser()
        {
            try
            {
                CefSettings settings = new CefSettings();
                Cef.Initialize(settings);

                //main browser
                chrome = new ChromiumWebBrowser(this.txt_url.Text.Trim());
                LifespanHandler life = new LifespanHandler();
                chrome.LifeSpanHandler = life;
                life.popup_request += life_popup_request;
                this.pan_container.Controls.Add(chrome);
                chrome.Dock = DockStyle.Fill;

                //popup browser
                chrome_popup = new ChromiumWebBrowser("");
                this.pan_container_popup.Controls.Add(chrome_popup);
                chrome_popup.Dock = DockStyle.Fill;

            }
            catch (Exception ex)
            {
                MessageBox.Show("Error in initializing the browser. Error: " + ex.Message);
            }
        }

        private string get_root_directory()
        {
            // get directory where exe is executing
            string path = System.Environment.CurrentDirectory;

            //find index initiale paste bin
            int indice = path.IndexOf("bin");

            //get path root directory project
            path = path.Substring(0, indice);

            return path.Replace(@"\", @"/");
        }

        private void carregar_popup_new_browser(string url)
        {
            //open pop up in second browser
            chrome_popup.Load(url);
        }

        private void frm_main_FormClosing(object sender, FormClosingEventArgs e)
        {
            //close o object cef
            Cef.Shutdown();
            Application.Exit();
        }

        private void frm_main_Load(object sender, EventArgs e)
        {
            this.txt_url.Text = "file:///" + get_root_directory() + "page_test.html";

            //initialize the browser
            this.initialize_browser();
        }

        #region life_popup_request(string obj)
        private void life_popup_request(string obj)
        {
            //function for open pop up in a new browser
            this.carregar_popup_new_browser(obj);
        }
        #endregion

        private void btn_ok_Click(object sender, EventArgs e)
        {
            try
            {
                //this button will opening a new site

                //verify if the textbox is empty
                if (this.txt_url.Text.Trim() == "")
                {
                    MessageBox.Show("The url must be filled");
                    return;
                }

                //open a new site
                chrome.Load(this.txt_url.Text.Trim());
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error in open the site. Error:" + ex.Message);
            }
        }
    }
}
